'''
mimeparse module, version 0.1

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import os,re
import email,mimetypes

allowed_chars='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789._-'

class savemail(ascanner):
      def __init__(self,dir):
          self.dir=dir
          self.filename='part-a'
      def scanstream(self,data):
          fp=open(os.path.join(self.dir,self.filename), 'wb')
          fp.write(data)
          fp.close()
          return '',[]

class mime_ext_int(ascanner):
      def __init__(self,wrong_type):
          self.filename=''
          self.wrong_type=wrong_type
      def scanstream(self,data):
          if (self.wrong_type!='') and (type(self.filename)==type('string')):
            if re.search(self.wrong_type,self.filename):
               return 'MatchedExtension', [self.filename+' matched\n']
          return '',[]

def decode_email(data,scanner):
    msg=email.message_from_string(data)
    files=[]
    counter=1
    vir,ret='',[]
    for part in msg.walk():
      if part.get_content_maintype()=='multipart':
        continue
      counter=counter+1
      sfn=part.get_filename()
      if sfn:
        scanner.filename=''
        for chp in range(len(sfn)):
          if not sfn[chp] in allowed_chars:
            scanner.filename=scanner.filename+'_'
          else:
            scanner.filename=scanner.filename+sfn[chp]
      else:
        try:
          ext = mimetypes.guess_extension(part.get_type())
        except:
          ext='.bin'
        if not ext:
          ext='.bin'
        scanner.filename = 'part-%03d%s' % (counter, ext)
      stream=part.get_payload(decode=1)
      if stream:
        v,r=scanner.scanstream(stream)
        files.append(scanner.filename)
        if not vir:
          vir=v
        ret=ret+r
    return vir,ret,files

class mimeparse(ascanner):
  def __init__(self,scanner):
      self.name='MimeParse('+scanner.name+')'
      self.scanner=scanner
  def scanstream(self,stream):
      mboxdir=smktemp('.mbd')
      os.mkdir(mboxdir,0770)
      vir,ret,filelist=decode_email(stream,savemail(mboxdir))
      try:
        vir,ret=self.scanner.scanfile(filelist,mboxdir)
      except:
        for f in filelist:
          os.unlink(os.path.join(mboxdir,f))
        os.rmdir(mboxdir)
        raise
      for f in filelist:
        os.unlink(os.path.join(mboxdir,f))
      os.rmdir(mboxdir)
      return vir,ret

class mimeparse_stream(ascanner):
  def __init__(self,scanner):
      self.name="MimeParse_stream("+scanner.name+")"
      self.scanner=scanner
  def scanstream(self,stream):
      vir,ret,filelist=decode_email(stream,self.scanner)
      return vir,ret

class mime_ext(ascanner):
  name='MimeExt'
  def __init__(self,wrong_type=''):
      self.wrong_type=wrong_type
  def scanstream(self,stream):
      vir,ret,filelist=decode_email(stream,mime_ext_int(self.wrong_type))
      return vir,ret
